/*
 * Copyright (c) 2021-2025 Golubchikov Mihail <https://github.com/rue-ryuzaki>
 */

#include "./argparse_test.hpp"

#include <map>

TEST_CASE("1. unicode to upper", "[detail]")
{
    SECTION("1.1. table symbols") {
        std::map<uint32_t, uint32_t> table_map;
        table_map[0x0061] = 0x0041;
        table_map[0x0062] = 0x0042;
        table_map[0x0063] = 0x0043;
        table_map[0x0064] = 0x0044;
        table_map[0x0065] = 0x0045;
        table_map[0x0066] = 0x0046;
        table_map[0x0067] = 0x0047;
        table_map[0x0068] = 0x0048;
        table_map[0x0069] = 0x0049;
        table_map[0x006a] = 0x004a;
        table_map[0x006b] = 0x004b;
        table_map[0x006c] = 0x004c;
        table_map[0x006d] = 0x004d;
        table_map[0x006e] = 0x004e;
        table_map[0x006f] = 0x004f;
        table_map[0x0070] = 0x0050;
        table_map[0x0071] = 0x0051;
        table_map[0x0072] = 0x0052;
        table_map[0x0073] = 0x0053;
        table_map[0x0074] = 0x0054;
        table_map[0x0075] = 0x0055;
        table_map[0x0076] = 0x0056;
        table_map[0x0077] = 0x0057;
        table_map[0x0078] = 0x0058;
        table_map[0x0079] = 0x0059;
        table_map[0x007a] = 0x005a;
        table_map[0x00b5] = 0x039c;
        table_map[0x00e0] = 0x00c0;
        table_map[0x00e1] = 0x00c1;
        table_map[0x00e2] = 0x00c2;
        table_map[0x00e3] = 0x00c3;
        table_map[0x00e4] = 0x00c4;
        table_map[0x00e5] = 0x00c5;
        table_map[0x00e6] = 0x00c6;
        table_map[0x00e7] = 0x00c7;
        table_map[0x00e8] = 0x00c8;
        table_map[0x00e9] = 0x00c9;
        table_map[0x00ea] = 0x00ca;
        table_map[0x00eb] = 0x00cb;
        table_map[0x00ec] = 0x00cc;
        table_map[0x00ed] = 0x00cd;
        table_map[0x00ee] = 0x00ce;
        table_map[0x00ef] = 0x00cf;
        table_map[0x00f0] = 0x00d0;
        table_map[0x00f1] = 0x00d1;
        table_map[0x00f2] = 0x00d2;
        table_map[0x00f3] = 0x00d3;
        table_map[0x00f4] = 0x00d4;
        table_map[0x00f5] = 0x00d5;
        table_map[0x00f6] = 0x00d6;
        table_map[0x00f8] = 0x00d8;
        table_map[0x00f9] = 0x00d9;
        table_map[0x00fa] = 0x00da;
        table_map[0x00fb] = 0x00db;
        table_map[0x00fc] = 0x00dc;
        table_map[0x00fd] = 0x00dd;
        table_map[0x00fe] = 0x00de;
        table_map[0x00ff] = 0x0178;
        table_map[0x0101] = 0x0100;
        table_map[0x0103] = 0x0102;
        table_map[0x0105] = 0x0104;
        table_map[0x0107] = 0x0106;
        table_map[0x0109] = 0x0108;
        table_map[0x010b] = 0x010a;
        table_map[0x010d] = 0x010c;
        table_map[0x010f] = 0x010e;
        table_map[0x0111] = 0x0110;
        table_map[0x0113] = 0x0112;
        table_map[0x0115] = 0x0114;
        table_map[0x0117] = 0x0116;
        table_map[0x0119] = 0x0118;
        table_map[0x011b] = 0x011a;
        table_map[0x011d] = 0x011c;
        table_map[0x011f] = 0x011e;
        table_map[0x0121] = 0x0120;
        table_map[0x0123] = 0x0122;
        table_map[0x0125] = 0x0124;
        table_map[0x0127] = 0x0126;
        table_map[0x0129] = 0x0128;
        table_map[0x012b] = 0x012a;
        table_map[0x012d] = 0x012c;
        table_map[0x012f] = 0x012e;
        table_map[0x0131] = 0x0049;
        table_map[0x0133] = 0x0132;
        table_map[0x0135] = 0x0134;
        table_map[0x0137] = 0x0136;
        table_map[0x013a] = 0x0139;
        table_map[0x013c] = 0x013b;
        table_map[0x013e] = 0x013d;
        table_map[0x0140] = 0x013f;
        table_map[0x0142] = 0x0141;
        table_map[0x0144] = 0x0143;
        table_map[0x0146] = 0x0145;
        table_map[0x0148] = 0x0147;
        table_map[0x014b] = 0x014a;
        table_map[0x014d] = 0x014c;
        table_map[0x014f] = 0x014e;
        table_map[0x0151] = 0x0150;
        table_map[0x0153] = 0x0152;
        table_map[0x0155] = 0x0154;
        table_map[0x0157] = 0x0156;
        table_map[0x0159] = 0x0158;
        table_map[0x015b] = 0x015a;
        table_map[0x015d] = 0x015c;
        table_map[0x015f] = 0x015e;
        table_map[0x0161] = 0x0160;
        table_map[0x0163] = 0x0162;
        table_map[0x0165] = 0x0164;
        table_map[0x0167] = 0x0166;
        table_map[0x0169] = 0x0168;
        table_map[0x016b] = 0x016a;
        table_map[0x016d] = 0x016c;
        table_map[0x016f] = 0x016e;
        table_map[0x0171] = 0x0170;
        table_map[0x0173] = 0x0172;
        table_map[0x0175] = 0x0174;
        table_map[0x0177] = 0x0176;
        table_map[0x017a] = 0x0179;
        table_map[0x017c] = 0x017b;
        table_map[0x017e] = 0x017d;
        table_map[0x017f] = 0x0053;
        table_map[0x0180] = 0x0243;
        table_map[0x0183] = 0x0182;
        table_map[0x0185] = 0x0184;
        table_map[0x0188] = 0x0187;
        table_map[0x018c] = 0x018b;
        table_map[0x0192] = 0x0191;
        table_map[0x0195] = 0x01f6;
        table_map[0x0199] = 0x0198;
        table_map[0x019a] = 0x023d;
        table_map[0x019b] = 0xa7dc;
        table_map[0x019e] = 0x0220;
        table_map[0x01a1] = 0x01a0;
        table_map[0x01a3] = 0x01a2;
        table_map[0x01a5] = 0x01a4;
        table_map[0x01a8] = 0x01a7;
        table_map[0x01ad] = 0x01ac;
        table_map[0x01b0] = 0x01af;
        table_map[0x01b4] = 0x01b3;
        table_map[0x01b6] = 0x01b5;
        table_map[0x01b9] = 0x01b8;
        table_map[0x01bd] = 0x01bc;
        table_map[0x01bf] = 0x01f7;
        table_map[0x01c5] = 0x01c4;
        table_map[0x01c6] = 0x01c4;
        table_map[0x01c8] = 0x01c7;
        table_map[0x01c9] = 0x01c7;
        table_map[0x01cb] = 0x01ca;
        table_map[0x01cc] = 0x01ca;
        table_map[0x01ce] = 0x01cd;
        table_map[0x01d0] = 0x01cf;
        table_map[0x01d2] = 0x01d1;
        table_map[0x01d4] = 0x01d3;
        table_map[0x01d6] = 0x01d5;
        table_map[0x01d8] = 0x01d7;
        table_map[0x01da] = 0x01d9;
        table_map[0x01dc] = 0x01db;
        table_map[0x01dd] = 0x018e;
        table_map[0x01df] = 0x01de;
        table_map[0x01e1] = 0x01e0;
        table_map[0x01e3] = 0x01e2;
        table_map[0x01e5] = 0x01e4;
        table_map[0x01e7] = 0x01e6;
        table_map[0x01e9] = 0x01e8;
        table_map[0x01eb] = 0x01ea;
        table_map[0x01ed] = 0x01ec;
        table_map[0x01ef] = 0x01ee;
        table_map[0x01f2] = 0x01f1;
        table_map[0x01f3] = 0x01f1;
        table_map[0x01f5] = 0x01f4;
        table_map[0x01f9] = 0x01f8;
        table_map[0x01fb] = 0x01fa;
        table_map[0x01fd] = 0x01fc;
        table_map[0x01ff] = 0x01fe;
        table_map[0x0201] = 0x0200;
        table_map[0x0203] = 0x0202;
        table_map[0x0205] = 0x0204;
        table_map[0x0207] = 0x0206;
        table_map[0x0209] = 0x0208;
        table_map[0x020b] = 0x020a;
        table_map[0x020d] = 0x020c;
        table_map[0x020f] = 0x020e;
        table_map[0x0211] = 0x0210;
        table_map[0x0213] = 0x0212;
        table_map[0x0215] = 0x0214;
        table_map[0x0217] = 0x0216;
        table_map[0x0219] = 0x0218;
        table_map[0x021b] = 0x021a;
        table_map[0x021d] = 0x021c;
        table_map[0x021f] = 0x021e;
        table_map[0x0223] = 0x0222;
        table_map[0x0225] = 0x0224;
        table_map[0x0227] = 0x0226;
        table_map[0x0229] = 0x0228;
        table_map[0x022b] = 0x022a;
        table_map[0x022d] = 0x022c;
        table_map[0x022f] = 0x022e;
        table_map[0x0231] = 0x0230;
        table_map[0x0233] = 0x0232;
        table_map[0x023c] = 0x023b;
        table_map[0x023f] = 0x2c7e;
        table_map[0x0240] = 0x2c7f;
        table_map[0x0242] = 0x0241;
        table_map[0x0247] = 0x0246;
        table_map[0x0249] = 0x0248;
        table_map[0x024b] = 0x024a;
        table_map[0x024d] = 0x024c;
        table_map[0x024f] = 0x024e;
        table_map[0x0250] = 0x2c6f;
        table_map[0x0251] = 0x2c6d;
        table_map[0x0252] = 0x2c70;
        table_map[0x0253] = 0x0181;
        table_map[0x0254] = 0x0186;
        table_map[0x0256] = 0x0189;
        table_map[0x0257] = 0x018a;
        table_map[0x0259] = 0x018f;
        table_map[0x025b] = 0x0190;
        table_map[0x025c] = 0xa7ab;
        table_map[0x0260] = 0x0193;
        table_map[0x0261] = 0xa7ac;
        table_map[0x0263] = 0x0194;
        table_map[0x0264] = 0xa7cb;
        table_map[0x0265] = 0xa78d;
        table_map[0x0266] = 0xa7aa;
        table_map[0x0268] = 0x0197;
        table_map[0x0269] = 0x0196;
        table_map[0x026a] = 0xa7ae;
        table_map[0x026b] = 0x2c62;
        table_map[0x026c] = 0xa7ad;
        table_map[0x026f] = 0x019c;
        table_map[0x0271] = 0x2c6e;
        table_map[0x0272] = 0x019d;
        table_map[0x0275] = 0x019f;
        table_map[0x027d] = 0x2c64;
        table_map[0x0280] = 0x01a6;
        table_map[0x0282] = 0xa7c5;
        table_map[0x0283] = 0x01a9;
        table_map[0x0287] = 0xa7b1;
        table_map[0x0288] = 0x01ae;
        table_map[0x0289] = 0x0244;
        table_map[0x028a] = 0x01b1;
        table_map[0x028b] = 0x01b2;
        table_map[0x028c] = 0x0245;
        table_map[0x0292] = 0x01b7;
        table_map[0x029d] = 0xa7b2;
        table_map[0x029e] = 0xa7b0;
        table_map[0x0345] = 0x0399;
        table_map[0x0371] = 0x0370;
        table_map[0x0373] = 0x0372;
        table_map[0x0377] = 0x0376;
        table_map[0x037b] = 0x03fd;
        table_map[0x037c] = 0x03fe;
        table_map[0x037d] = 0x03ff;
        table_map[0x03ac] = 0x0386;
        table_map[0x03ad] = 0x0388;
        table_map[0x03ae] = 0x0389;
        table_map[0x03af] = 0x038a;
        table_map[0x03b1] = 0x0391;
        table_map[0x03b2] = 0x0392;
        table_map[0x03b3] = 0x0393;
        table_map[0x03b4] = 0x0394;
        table_map[0x03b5] = 0x0395;
        table_map[0x03b6] = 0x0396;
        table_map[0x03b7] = 0x0397;
        table_map[0x03b8] = 0x0398;
        table_map[0x03b9] = 0x0399;
        table_map[0x03ba] = 0x039a;
        table_map[0x03bb] = 0x039b;
        table_map[0x03bc] = 0x039c;
        table_map[0x03bd] = 0x039d;
        table_map[0x03be] = 0x039e;
        table_map[0x03bf] = 0x039f;
        table_map[0x03c0] = 0x03a0;
        table_map[0x03c1] = 0x03a1;
        table_map[0x03c2] = 0x03a3;
        table_map[0x03c3] = 0x03a3;
        table_map[0x03c4] = 0x03a4;
        table_map[0x03c5] = 0x03a5;
        table_map[0x03c6] = 0x03a6;
        table_map[0x03c7] = 0x03a7;
        table_map[0x03c8] = 0x03a8;
        table_map[0x03c9] = 0x03a9;
        table_map[0x03ca] = 0x03aa;
        table_map[0x03cb] = 0x03ab;
        table_map[0x03cc] = 0x038c;
        table_map[0x03cd] = 0x038e;
        table_map[0x03ce] = 0x038f;
        table_map[0x03d0] = 0x0392;
        table_map[0x03d1] = 0x0398;
        table_map[0x03d5] = 0x03a6;
        table_map[0x03d6] = 0x03a0;
        table_map[0x03d7] = 0x03cf;
        table_map[0x03d9] = 0x03d8;
        table_map[0x03db] = 0x03da;
        table_map[0x03dd] = 0x03dc;
        table_map[0x03df] = 0x03de;
        table_map[0x03e1] = 0x03e0;
        table_map[0x03e3] = 0x03e2;
        table_map[0x03e5] = 0x03e4;
        table_map[0x03e7] = 0x03e6;
        table_map[0x03e9] = 0x03e8;
        table_map[0x03eb] = 0x03ea;
        table_map[0x03ed] = 0x03ec;
        table_map[0x03ef] = 0x03ee;
        table_map[0x03f0] = 0x039a;
        table_map[0x03f1] = 0x03a1;
        table_map[0x03f2] = 0x03f9;
        table_map[0x03f3] = 0x037f;
        table_map[0x03f5] = 0x0395;
        table_map[0x03f8] = 0x03f7;
        table_map[0x03fb] = 0x03fa;
        table_map[0x0430] = 0x0410;
        table_map[0x0431] = 0x0411;
        table_map[0x0432] = 0x0412;
        table_map[0x0433] = 0x0413;
        table_map[0x0434] = 0x0414;
        table_map[0x0435] = 0x0415;
        table_map[0x0436] = 0x0416;
        table_map[0x0437] = 0x0417;
        table_map[0x0438] = 0x0418;
        table_map[0x0439] = 0x0419;
        table_map[0x043a] = 0x041a;
        table_map[0x043b] = 0x041b;
        table_map[0x043c] = 0x041c;
        table_map[0x043d] = 0x041d;
        table_map[0x043e] = 0x041e;
        table_map[0x043f] = 0x041f;
        table_map[0x0440] = 0x0420;
        table_map[0x0441] = 0x0421;
        table_map[0x0442] = 0x0422;
        table_map[0x0443] = 0x0423;
        table_map[0x0444] = 0x0424;
        table_map[0x0445] = 0x0425;
        table_map[0x0446] = 0x0426;
        table_map[0x0447] = 0x0427;
        table_map[0x0448] = 0x0428;
        table_map[0x0449] = 0x0429;
        table_map[0x044a] = 0x042a;
        table_map[0x044b] = 0x042b;
        table_map[0x044c] = 0x042c;
        table_map[0x044d] = 0x042d;
        table_map[0x044e] = 0x042e;
        table_map[0x044f] = 0x042f;
        table_map[0x0450] = 0x0400;
        table_map[0x0451] = 0x0401;
        table_map[0x0452] = 0x0402;
        table_map[0x0453] = 0x0403;
        table_map[0x0454] = 0x0404;
        table_map[0x0455] = 0x0405;
        table_map[0x0456] = 0x0406;
        table_map[0x0457] = 0x0407;
        table_map[0x0458] = 0x0408;
        table_map[0x0459] = 0x0409;
        table_map[0x045a] = 0x040a;
        table_map[0x045b] = 0x040b;
        table_map[0x045c] = 0x040c;
        table_map[0x045d] = 0x040d;
        table_map[0x045e] = 0x040e;
        table_map[0x045f] = 0x040f;
        table_map[0x0461] = 0x0460;
        table_map[0x0463] = 0x0462;
        table_map[0x0465] = 0x0464;
        table_map[0x0467] = 0x0466;
        table_map[0x0469] = 0x0468;
        table_map[0x046b] = 0x046a;
        table_map[0x046d] = 0x046c;
        table_map[0x046f] = 0x046e;
        table_map[0x0471] = 0x0470;
        table_map[0x0473] = 0x0472;
        table_map[0x0475] = 0x0474;
        table_map[0x0477] = 0x0476;
        table_map[0x0479] = 0x0478;
        table_map[0x047b] = 0x047a;
        table_map[0x047d] = 0x047c;
        table_map[0x047f] = 0x047e;
        table_map[0x0481] = 0x0480;
        table_map[0x048b] = 0x048a;
        table_map[0x048d] = 0x048c;
        table_map[0x048f] = 0x048e;
        table_map[0x0491] = 0x0490;
        table_map[0x0493] = 0x0492;
        table_map[0x0495] = 0x0494;
        table_map[0x0497] = 0x0496;
        table_map[0x0499] = 0x0498;
        table_map[0x049b] = 0x049a;
        table_map[0x049d] = 0x049c;
        table_map[0x049f] = 0x049e;
        table_map[0x04a1] = 0x04a0;
        table_map[0x04a3] = 0x04a2;
        table_map[0x04a5] = 0x04a4;
        table_map[0x04a7] = 0x04a6;
        table_map[0x04a9] = 0x04a8;
        table_map[0x04ab] = 0x04aa;
        table_map[0x04ad] = 0x04ac;
        table_map[0x04af] = 0x04ae;
        table_map[0x04b1] = 0x04b0;
        table_map[0x04b3] = 0x04b2;
        table_map[0x04b5] = 0x04b4;
        table_map[0x04b7] = 0x04b6;
        table_map[0x04b9] = 0x04b8;
        table_map[0x04bb] = 0x04ba;
        table_map[0x04bd] = 0x04bc;
        table_map[0x04bf] = 0x04be;
        table_map[0x04c2] = 0x04c1;
        table_map[0x04c4] = 0x04c3;
        table_map[0x04c6] = 0x04c5;
        table_map[0x04c8] = 0x04c7;
        table_map[0x04ca] = 0x04c9;
        table_map[0x04cc] = 0x04cb;
        table_map[0x04ce] = 0x04cd;
        table_map[0x04cf] = 0x04c0;
        table_map[0x04d1] = 0x04d0;
        table_map[0x04d3] = 0x04d2;
        table_map[0x04d5] = 0x04d4;
        table_map[0x04d7] = 0x04d6;
        table_map[0x04d9] = 0x04d8;
        table_map[0x04db] = 0x04da;
        table_map[0x04dd] = 0x04dc;
        table_map[0x04df] = 0x04de;
        table_map[0x04e1] = 0x04e0;
        table_map[0x04e3] = 0x04e2;
        table_map[0x04e5] = 0x04e4;
        table_map[0x04e7] = 0x04e6;
        table_map[0x04e9] = 0x04e8;
        table_map[0x04eb] = 0x04ea;
        table_map[0x04ed] = 0x04ec;
        table_map[0x04ef] = 0x04ee;
        table_map[0x04f1] = 0x04f0;
        table_map[0x04f3] = 0x04f2;
        table_map[0x04f5] = 0x04f4;
        table_map[0x04f7] = 0x04f6;
        table_map[0x04f9] = 0x04f8;
        table_map[0x04fb] = 0x04fa;
        table_map[0x04fd] = 0x04fc;
        table_map[0x04ff] = 0x04fe;
        table_map[0x0501] = 0x0500;
        table_map[0x0503] = 0x0502;
        table_map[0x0505] = 0x0504;
        table_map[0x0507] = 0x0506;
        table_map[0x0509] = 0x0508;
        table_map[0x050b] = 0x050a;
        table_map[0x050d] = 0x050c;
        table_map[0x050f] = 0x050e;
        table_map[0x0511] = 0x0510;
        table_map[0x0513] = 0x0512;
        table_map[0x0515] = 0x0514;
        table_map[0x0517] = 0x0516;
        table_map[0x0519] = 0x0518;
        table_map[0x051b] = 0x051a;
        table_map[0x051d] = 0x051c;
        table_map[0x051f] = 0x051e;
        table_map[0x0521] = 0x0520;
        table_map[0x0523] = 0x0522;
        table_map[0x0525] = 0x0524;
        table_map[0x0527] = 0x0526;
        table_map[0x0529] = 0x0528;
        table_map[0x052b] = 0x052a;
        table_map[0x052d] = 0x052c;
        table_map[0x052f] = 0x052e;
        table_map[0x0561] = 0x0531;
        table_map[0x0562] = 0x0532;
        table_map[0x0563] = 0x0533;
        table_map[0x0564] = 0x0534;
        table_map[0x0565] = 0x0535;
        table_map[0x0566] = 0x0536;
        table_map[0x0567] = 0x0537;
        table_map[0x0568] = 0x0538;
        table_map[0x0569] = 0x0539;
        table_map[0x056a] = 0x053a;
        table_map[0x056b] = 0x053b;
        table_map[0x056c] = 0x053c;
        table_map[0x056d] = 0x053d;
        table_map[0x056e] = 0x053e;
        table_map[0x056f] = 0x053f;
        table_map[0x0570] = 0x0540;
        table_map[0x0571] = 0x0541;
        table_map[0x0572] = 0x0542;
        table_map[0x0573] = 0x0543;
        table_map[0x0574] = 0x0544;
        table_map[0x0575] = 0x0545;
        table_map[0x0576] = 0x0546;
        table_map[0x0577] = 0x0547;
        table_map[0x0578] = 0x0548;
        table_map[0x0579] = 0x0549;
        table_map[0x057a] = 0x054a;
        table_map[0x057b] = 0x054b;
        table_map[0x057c] = 0x054c;
        table_map[0x057d] = 0x054d;
        table_map[0x057e] = 0x054e;
        table_map[0x057f] = 0x054f;
        table_map[0x0580] = 0x0550;
        table_map[0x0581] = 0x0551;
        table_map[0x0582] = 0x0552;
        table_map[0x0583] = 0x0553;
        table_map[0x0584] = 0x0554;
        table_map[0x0585] = 0x0555;
        table_map[0x0586] = 0x0556;
        table_map[0x10d0] = 0x1c90;
        table_map[0x10d1] = 0x1c91;
        table_map[0x10d2] = 0x1c92;
        table_map[0x10d3] = 0x1c93;
        table_map[0x10d4] = 0x1c94;
        table_map[0x10d5] = 0x1c95;
        table_map[0x10d6] = 0x1c96;
        table_map[0x10d7] = 0x1c97;
        table_map[0x10d8] = 0x1c98;
        table_map[0x10d9] = 0x1c99;
        table_map[0x10da] = 0x1c9a;
        table_map[0x10db] = 0x1c9b;
        table_map[0x10dc] = 0x1c9c;
        table_map[0x10dd] = 0x1c9d;
        table_map[0x10de] = 0x1c9e;
        table_map[0x10df] = 0x1c9f;
        table_map[0x10e0] = 0x1ca0;
        table_map[0x10e1] = 0x1ca1;
        table_map[0x10e2] = 0x1ca2;
        table_map[0x10e3] = 0x1ca3;
        table_map[0x10e4] = 0x1ca4;
        table_map[0x10e5] = 0x1ca5;
        table_map[0x10e6] = 0x1ca6;
        table_map[0x10e7] = 0x1ca7;
        table_map[0x10e8] = 0x1ca8;
        table_map[0x10e9] = 0x1ca9;
        table_map[0x10ea] = 0x1caa;
        table_map[0x10eb] = 0x1cab;
        table_map[0x10ec] = 0x1cac;
        table_map[0x10ed] = 0x1cad;
        table_map[0x10ee] = 0x1cae;
        table_map[0x10ef] = 0x1caf;
        table_map[0x10f0] = 0x1cb0;
        table_map[0x10f1] = 0x1cb1;
        table_map[0x10f2] = 0x1cb2;
        table_map[0x10f3] = 0x1cb3;
        table_map[0x10f4] = 0x1cb4;
        table_map[0x10f5] = 0x1cb5;
        table_map[0x10f6] = 0x1cb6;
        table_map[0x10f7] = 0x1cb7;
        table_map[0x10f8] = 0x1cb8;
        table_map[0x10f9] = 0x1cb9;
        table_map[0x10fa] = 0x1cba;
        table_map[0x10fd] = 0x1cbd;
        table_map[0x10fe] = 0x1cbe;
        table_map[0x10ff] = 0x1cbf;
        table_map[0x13f8] = 0x13f0;
        table_map[0x13f9] = 0x13f1;
        table_map[0x13fa] = 0x13f2;
        table_map[0x13fb] = 0x13f3;
        table_map[0x13fc] = 0x13f4;
        table_map[0x13fd] = 0x13f5;
        table_map[0x1c80] = 0x0412;
        table_map[0x1c81] = 0x0414;
        table_map[0x1c82] = 0x041e;
        table_map[0x1c83] = 0x0421;
        table_map[0x1c84] = 0x0422;
        table_map[0x1c85] = 0x0422;
        table_map[0x1c86] = 0x042a;
        table_map[0x1c87] = 0x0462;
        table_map[0x1c88] = 0xa64a;
        table_map[0x1c8a] = 0x1c89;
        table_map[0x1d79] = 0xa77d;
        table_map[0x1d7d] = 0x2c63;
        table_map[0x1d8e] = 0xa7c6;
        table_map[0x1e01] = 0x1e00;
        table_map[0x1e03] = 0x1e02;
        table_map[0x1e05] = 0x1e04;
        table_map[0x1e07] = 0x1e06;
        table_map[0x1e09] = 0x1e08;
        table_map[0x1e0b] = 0x1e0a;
        table_map[0x1e0d] = 0x1e0c;
        table_map[0x1e0f] = 0x1e0e;
        table_map[0x1e11] = 0x1e10;
        table_map[0x1e13] = 0x1e12;
        table_map[0x1e15] = 0x1e14;
        table_map[0x1e17] = 0x1e16;
        table_map[0x1e19] = 0x1e18;
        table_map[0x1e1b] = 0x1e1a;
        table_map[0x1e1d] = 0x1e1c;
        table_map[0x1e1f] = 0x1e1e;
        table_map[0x1e21] = 0x1e20;
        table_map[0x1e23] = 0x1e22;
        table_map[0x1e25] = 0x1e24;
        table_map[0x1e27] = 0x1e26;
        table_map[0x1e29] = 0x1e28;
        table_map[0x1e2b] = 0x1e2a;
        table_map[0x1e2d] = 0x1e2c;
        table_map[0x1e2f] = 0x1e2e;
        table_map[0x1e31] = 0x1e30;
        table_map[0x1e33] = 0x1e32;
        table_map[0x1e35] = 0x1e34;
        table_map[0x1e37] = 0x1e36;
        table_map[0x1e39] = 0x1e38;
        table_map[0x1e3b] = 0x1e3a;
        table_map[0x1e3d] = 0x1e3c;
        table_map[0x1e3f] = 0x1e3e;
        table_map[0x1e41] = 0x1e40;
        table_map[0x1e43] = 0x1e42;
        table_map[0x1e45] = 0x1e44;
        table_map[0x1e47] = 0x1e46;
        table_map[0x1e49] = 0x1e48;
        table_map[0x1e4b] = 0x1e4a;
        table_map[0x1e4d] = 0x1e4c;
        table_map[0x1e4f] = 0x1e4e;
        table_map[0x1e51] = 0x1e50;
        table_map[0x1e53] = 0x1e52;
        table_map[0x1e55] = 0x1e54;
        table_map[0x1e57] = 0x1e56;
        table_map[0x1e59] = 0x1e58;
        table_map[0x1e5b] = 0x1e5a;
        table_map[0x1e5d] = 0x1e5c;
        table_map[0x1e5f] = 0x1e5e;
        table_map[0x1e61] = 0x1e60;
        table_map[0x1e63] = 0x1e62;
        table_map[0x1e65] = 0x1e64;
        table_map[0x1e67] = 0x1e66;
        table_map[0x1e69] = 0x1e68;
        table_map[0x1e6b] = 0x1e6a;
        table_map[0x1e6d] = 0x1e6c;
        table_map[0x1e6f] = 0x1e6e;
        table_map[0x1e71] = 0x1e70;
        table_map[0x1e73] = 0x1e72;
        table_map[0x1e75] = 0x1e74;
        table_map[0x1e77] = 0x1e76;
        table_map[0x1e79] = 0x1e78;
        table_map[0x1e7b] = 0x1e7a;
        table_map[0x1e7d] = 0x1e7c;
        table_map[0x1e7f] = 0x1e7e;
        table_map[0x1e81] = 0x1e80;
        table_map[0x1e83] = 0x1e82;
        table_map[0x1e85] = 0x1e84;
        table_map[0x1e87] = 0x1e86;
        table_map[0x1e89] = 0x1e88;
        table_map[0x1e8b] = 0x1e8a;
        table_map[0x1e8d] = 0x1e8c;
        table_map[0x1e8f] = 0x1e8e;
        table_map[0x1e91] = 0x1e90;
        table_map[0x1e93] = 0x1e92;
        table_map[0x1e95] = 0x1e94;
        table_map[0x1e9b] = 0x1e60;
        table_map[0x1ea1] = 0x1ea0;
        table_map[0x1ea3] = 0x1ea2;
        table_map[0x1ea5] = 0x1ea4;
        table_map[0x1ea7] = 0x1ea6;
        table_map[0x1ea9] = 0x1ea8;
        table_map[0x1eab] = 0x1eaa;
        table_map[0x1ead] = 0x1eac;
        table_map[0x1eaf] = 0x1eae;
        table_map[0x1eb1] = 0x1eb0;
        table_map[0x1eb3] = 0x1eb2;
        table_map[0x1eb5] = 0x1eb4;
        table_map[0x1eb7] = 0x1eb6;
        table_map[0x1eb9] = 0x1eb8;
        table_map[0x1ebb] = 0x1eba;
        table_map[0x1ebd] = 0x1ebc;
        table_map[0x1ebf] = 0x1ebe;
        table_map[0x1ec1] = 0x1ec0;
        table_map[0x1ec3] = 0x1ec2;
        table_map[0x1ec5] = 0x1ec4;
        table_map[0x1ec7] = 0x1ec6;
        table_map[0x1ec9] = 0x1ec8;
        table_map[0x1ecb] = 0x1eca;
        table_map[0x1ecd] = 0x1ecc;
        table_map[0x1ecf] = 0x1ece;
        table_map[0x1ed1] = 0x1ed0;
        table_map[0x1ed3] = 0x1ed2;
        table_map[0x1ed5] = 0x1ed4;
        table_map[0x1ed7] = 0x1ed6;
        table_map[0x1ed9] = 0x1ed8;
        table_map[0x1edb] = 0x1eda;
        table_map[0x1edd] = 0x1edc;
        table_map[0x1edf] = 0x1ede;
        table_map[0x1ee1] = 0x1ee0;
        table_map[0x1ee3] = 0x1ee2;
        table_map[0x1ee5] = 0x1ee4;
        table_map[0x1ee7] = 0x1ee6;
        table_map[0x1ee9] = 0x1ee8;
        table_map[0x1eeb] = 0x1eea;
        table_map[0x1eed] = 0x1eec;
        table_map[0x1eef] = 0x1eee;
        table_map[0x1ef1] = 0x1ef0;
        table_map[0x1ef3] = 0x1ef2;
        table_map[0x1ef5] = 0x1ef4;
        table_map[0x1ef7] = 0x1ef6;
        table_map[0x1ef9] = 0x1ef8;
        table_map[0x1efb] = 0x1efa;
        table_map[0x1efd] = 0x1efc;
        table_map[0x1eff] = 0x1efe;
        table_map[0x1f00] = 0x1f08;
        table_map[0x1f01] = 0x1f09;
        table_map[0x1f02] = 0x1f0a;
        table_map[0x1f03] = 0x1f0b;
        table_map[0x1f04] = 0x1f0c;
        table_map[0x1f05] = 0x1f0d;
        table_map[0x1f06] = 0x1f0e;
        table_map[0x1f07] = 0x1f0f;
        table_map[0x1f10] = 0x1f18;
        table_map[0x1f11] = 0x1f19;
        table_map[0x1f12] = 0x1f1a;
        table_map[0x1f13] = 0x1f1b;
        table_map[0x1f14] = 0x1f1c;
        table_map[0x1f15] = 0x1f1d;
        table_map[0x1f20] = 0x1f28;
        table_map[0x1f21] = 0x1f29;
        table_map[0x1f22] = 0x1f2a;
        table_map[0x1f23] = 0x1f2b;
        table_map[0x1f24] = 0x1f2c;
        table_map[0x1f25] = 0x1f2d;
        table_map[0x1f26] = 0x1f2e;
        table_map[0x1f27] = 0x1f2f;
        table_map[0x1f30] = 0x1f38;
        table_map[0x1f31] = 0x1f39;
        table_map[0x1f32] = 0x1f3a;
        table_map[0x1f33] = 0x1f3b;
        table_map[0x1f34] = 0x1f3c;
        table_map[0x1f35] = 0x1f3d;
        table_map[0x1f36] = 0x1f3e;
        table_map[0x1f37] = 0x1f3f;
        table_map[0x1f40] = 0x1f48;
        table_map[0x1f41] = 0x1f49;
        table_map[0x1f42] = 0x1f4a;
        table_map[0x1f43] = 0x1f4b;
        table_map[0x1f44] = 0x1f4c;
        table_map[0x1f45] = 0x1f4d;
        table_map[0x1f51] = 0x1f59;
        table_map[0x1f53] = 0x1f5b;
        table_map[0x1f55] = 0x1f5d;
        table_map[0x1f57] = 0x1f5f;
        table_map[0x1f60] = 0x1f68;
        table_map[0x1f61] = 0x1f69;
        table_map[0x1f62] = 0x1f6a;
        table_map[0x1f63] = 0x1f6b;
        table_map[0x1f64] = 0x1f6c;
        table_map[0x1f65] = 0x1f6d;
        table_map[0x1f66] = 0x1f6e;
        table_map[0x1f67] = 0x1f6f;
        table_map[0x1f70] = 0x1fba;
        table_map[0x1f71] = 0x1fbb;
        table_map[0x1f72] = 0x1fc8;
        table_map[0x1f73] = 0x1fc9;
        table_map[0x1f74] = 0x1fca;
        table_map[0x1f75] = 0x1fcb;
        table_map[0x1f76] = 0x1fda;
        table_map[0x1f77] = 0x1fdb;
        table_map[0x1f78] = 0x1ff8;
        table_map[0x1f79] = 0x1ff9;
        table_map[0x1f7a] = 0x1fea;
        table_map[0x1f7b] = 0x1feb;
        table_map[0x1f7c] = 0x1ffa;
        table_map[0x1f7d] = 0x1ffb;
        table_map[0x1f80] = 0x1f88;
        table_map[0x1f81] = 0x1f89;
        table_map[0x1f82] = 0x1f8a;
        table_map[0x1f83] = 0x1f8b;
        table_map[0x1f84] = 0x1f8c;
        table_map[0x1f85] = 0x1f8d;
        table_map[0x1f86] = 0x1f8e;
        table_map[0x1f87] = 0x1f8f;
        table_map[0x1f90] = 0x1f98;
        table_map[0x1f91] = 0x1f99;
        table_map[0x1f92] = 0x1f9a;
        table_map[0x1f93] = 0x1f9b;
        table_map[0x1f94] = 0x1f9c;
        table_map[0x1f95] = 0x1f9d;
        table_map[0x1f96] = 0x1f9e;
        table_map[0x1f97] = 0x1f9f;
        table_map[0x1fa0] = 0x1fa8;
        table_map[0x1fa1] = 0x1fa9;
        table_map[0x1fa2] = 0x1faa;
        table_map[0x1fa3] = 0x1fab;
        table_map[0x1fa4] = 0x1fac;
        table_map[0x1fa5] = 0x1fad;
        table_map[0x1fa6] = 0x1fae;
        table_map[0x1fa7] = 0x1faf;
        table_map[0x1fb0] = 0x1fb8;
        table_map[0x1fb1] = 0x1fb9;
        table_map[0x1fb3] = 0x1fbc;
        table_map[0x1fbe] = 0x0399;
        table_map[0x1fc3] = 0x1fcc;
        table_map[0x1fd0] = 0x1fd8;
        table_map[0x1fd1] = 0x1fd9;
        table_map[0x1fe0] = 0x1fe8;
        table_map[0x1fe1] = 0x1fe9;
        table_map[0x1fe5] = 0x1fec;
        table_map[0x1ff3] = 0x1ffc;
        table_map[0x214e] = 0x2132;
        table_map[0x2170] = 0x2160;
        table_map[0x2171] = 0x2161;
        table_map[0x2172] = 0x2162;
        table_map[0x2173] = 0x2163;
        table_map[0x2174] = 0x2164;
        table_map[0x2175] = 0x2165;
        table_map[0x2176] = 0x2166;
        table_map[0x2177] = 0x2167;
        table_map[0x2178] = 0x2168;
        table_map[0x2179] = 0x2169;
        table_map[0x217a] = 0x216a;
        table_map[0x217b] = 0x216b;
        table_map[0x217c] = 0x216c;
        table_map[0x217d] = 0x216d;
        table_map[0x217e] = 0x216e;
        table_map[0x217f] = 0x216f;
        table_map[0x2184] = 0x2183;
        table_map[0x24d0] = 0x24b6;
        table_map[0x24d1] = 0x24b7;
        table_map[0x24d2] = 0x24b8;
        table_map[0x24d3] = 0x24b9;
        table_map[0x24d4] = 0x24ba;
        table_map[0x24d5] = 0x24bb;
        table_map[0x24d6] = 0x24bc;
        table_map[0x24d7] = 0x24bd;
        table_map[0x24d8] = 0x24be;
        table_map[0x24d9] = 0x24bf;
        table_map[0x24da] = 0x24c0;
        table_map[0x24db] = 0x24c1;
        table_map[0x24dc] = 0x24c2;
        table_map[0x24dd] = 0x24c3;
        table_map[0x24de] = 0x24c4;
        table_map[0x24df] = 0x24c5;
        table_map[0x24e0] = 0x24c6;
        table_map[0x24e1] = 0x24c7;
        table_map[0x24e2] = 0x24c8;
        table_map[0x24e3] = 0x24c9;
        table_map[0x24e4] = 0x24ca;
        table_map[0x24e5] = 0x24cb;
        table_map[0x24e6] = 0x24cc;
        table_map[0x24e7] = 0x24cd;
        table_map[0x24e8] = 0x24ce;
        table_map[0x24e9] = 0x24cf;
        table_map[0x2c30] = 0x2c00;
        table_map[0x2c31] = 0x2c01;
        table_map[0x2c32] = 0x2c02;
        table_map[0x2c33] = 0x2c03;
        table_map[0x2c34] = 0x2c04;
        table_map[0x2c35] = 0x2c05;
        table_map[0x2c36] = 0x2c06;
        table_map[0x2c37] = 0x2c07;
        table_map[0x2c38] = 0x2c08;
        table_map[0x2c39] = 0x2c09;
        table_map[0x2c3a] = 0x2c0a;
        table_map[0x2c3b] = 0x2c0b;
        table_map[0x2c3c] = 0x2c0c;
        table_map[0x2c3d] = 0x2c0d;
        table_map[0x2c3e] = 0x2c0e;
        table_map[0x2c3f] = 0x2c0f;
        table_map[0x2c40] = 0x2c10;
        table_map[0x2c41] = 0x2c11;
        table_map[0x2c42] = 0x2c12;
        table_map[0x2c43] = 0x2c13;
        table_map[0x2c44] = 0x2c14;
        table_map[0x2c45] = 0x2c15;
        table_map[0x2c46] = 0x2c16;
        table_map[0x2c47] = 0x2c17;
        table_map[0x2c48] = 0x2c18;
        table_map[0x2c49] = 0x2c19;
        table_map[0x2c4a] = 0x2c1a;
        table_map[0x2c4b] = 0x2c1b;
        table_map[0x2c4c] = 0x2c1c;
        table_map[0x2c4d] = 0x2c1d;
        table_map[0x2c4e] = 0x2c1e;
        table_map[0x2c4f] = 0x2c1f;
        table_map[0x2c50] = 0x2c20;
        table_map[0x2c51] = 0x2c21;
        table_map[0x2c52] = 0x2c22;
        table_map[0x2c53] = 0x2c23;
        table_map[0x2c54] = 0x2c24;
        table_map[0x2c55] = 0x2c25;
        table_map[0x2c56] = 0x2c26;
        table_map[0x2c57] = 0x2c27;
        table_map[0x2c58] = 0x2c28;
        table_map[0x2c59] = 0x2c29;
        table_map[0x2c5a] = 0x2c2a;
        table_map[0x2c5b] = 0x2c2b;
        table_map[0x2c5c] = 0x2c2c;
        table_map[0x2c5d] = 0x2c2d;
        table_map[0x2c5e] = 0x2c2e;
        table_map[0x2c5f] = 0x2c2f;
        table_map[0x2c61] = 0x2c60;
        table_map[0x2c65] = 0x023a;
        table_map[0x2c66] = 0x023e;
        table_map[0x2c68] = 0x2c67;
        table_map[0x2c6a] = 0x2c69;
        table_map[0x2c6c] = 0x2c6b;
        table_map[0x2c73] = 0x2c72;
        table_map[0x2c76] = 0x2c75;
        table_map[0x2c81] = 0x2c80;
        table_map[0x2c83] = 0x2c82;
        table_map[0x2c85] = 0x2c84;
        table_map[0x2c87] = 0x2c86;
        table_map[0x2c89] = 0x2c88;
        table_map[0x2c8b] = 0x2c8a;
        table_map[0x2c8d] = 0x2c8c;
        table_map[0x2c8f] = 0x2c8e;
        table_map[0x2c91] = 0x2c90;
        table_map[0x2c93] = 0x2c92;
        table_map[0x2c95] = 0x2c94;
        table_map[0x2c97] = 0x2c96;
        table_map[0x2c99] = 0x2c98;
        table_map[0x2c9b] = 0x2c9a;
        table_map[0x2c9d] = 0x2c9c;
        table_map[0x2c9f] = 0x2c9e;
        table_map[0x2ca1] = 0x2ca0;
        table_map[0x2ca3] = 0x2ca2;
        table_map[0x2ca5] = 0x2ca4;
        table_map[0x2ca7] = 0x2ca6;
        table_map[0x2ca9] = 0x2ca8;
        table_map[0x2cab] = 0x2caa;
        table_map[0x2cad] = 0x2cac;
        table_map[0x2caf] = 0x2cae;
        table_map[0x2cb1] = 0x2cb0;
        table_map[0x2cb3] = 0x2cb2;
        table_map[0x2cb5] = 0x2cb4;
        table_map[0x2cb7] = 0x2cb6;
        table_map[0x2cb9] = 0x2cb8;
        table_map[0x2cbb] = 0x2cba;
        table_map[0x2cbd] = 0x2cbc;
        table_map[0x2cbf] = 0x2cbe;
        table_map[0x2cc1] = 0x2cc0;
        table_map[0x2cc3] = 0x2cc2;
        table_map[0x2cc5] = 0x2cc4;
        table_map[0x2cc7] = 0x2cc6;
        table_map[0x2cc9] = 0x2cc8;
        table_map[0x2ccb] = 0x2cca;
        table_map[0x2ccd] = 0x2ccc;
        table_map[0x2ccf] = 0x2cce;
        table_map[0x2cd1] = 0x2cd0;
        table_map[0x2cd3] = 0x2cd2;
        table_map[0x2cd5] = 0x2cd4;
        table_map[0x2cd7] = 0x2cd6;
        table_map[0x2cd9] = 0x2cd8;
        table_map[0x2cdb] = 0x2cda;
        table_map[0x2cdd] = 0x2cdc;
        table_map[0x2cdf] = 0x2cde;
        table_map[0x2ce1] = 0x2ce0;
        table_map[0x2ce3] = 0x2ce2;
        table_map[0x2cec] = 0x2ceb;
        table_map[0x2cee] = 0x2ced;
        table_map[0x2cf3] = 0x2cf2;
        table_map[0x2d00] = 0x10a0;
        table_map[0x2d01] = 0x10a1;
        table_map[0x2d02] = 0x10a2;
        table_map[0x2d03] = 0x10a3;
        table_map[0x2d04] = 0x10a4;
        table_map[0x2d05] = 0x10a5;
        table_map[0x2d06] = 0x10a6;
        table_map[0x2d07] = 0x10a7;
        table_map[0x2d08] = 0x10a8;
        table_map[0x2d09] = 0x10a9;
        table_map[0x2d0a] = 0x10aa;
        table_map[0x2d0b] = 0x10ab;
        table_map[0x2d0c] = 0x10ac;
        table_map[0x2d0d] = 0x10ad;
        table_map[0x2d0e] = 0x10ae;
        table_map[0x2d0f] = 0x10af;
        table_map[0x2d10] = 0x10b0;
        table_map[0x2d11] = 0x10b1;
        table_map[0x2d12] = 0x10b2;
        table_map[0x2d13] = 0x10b3;
        table_map[0x2d14] = 0x10b4;
        table_map[0x2d15] = 0x10b5;
        table_map[0x2d16] = 0x10b6;
        table_map[0x2d17] = 0x10b7;
        table_map[0x2d18] = 0x10b8;
        table_map[0x2d19] = 0x10b9;
        table_map[0x2d1a] = 0x10ba;
        table_map[0x2d1b] = 0x10bb;
        table_map[0x2d1c] = 0x10bc;
        table_map[0x2d1d] = 0x10bd;
        table_map[0x2d1e] = 0x10be;
        table_map[0x2d1f] = 0x10bf;
        table_map[0x2d20] = 0x10c0;
        table_map[0x2d21] = 0x10c1;
        table_map[0x2d22] = 0x10c2;
        table_map[0x2d23] = 0x10c3;
        table_map[0x2d24] = 0x10c4;
        table_map[0x2d25] = 0x10c5;
        table_map[0x2d27] = 0x10c7;
        table_map[0x2d2d] = 0x10cd;
        table_map[0xa641] = 0xa640;
        table_map[0xa643] = 0xa642;
        table_map[0xa645] = 0xa644;
        table_map[0xa647] = 0xa646;
        table_map[0xa649] = 0xa648;
        table_map[0xa64b] = 0xa64a;
        table_map[0xa64d] = 0xa64c;
        table_map[0xa64f] = 0xa64e;
        table_map[0xa651] = 0xa650;
        table_map[0xa653] = 0xa652;
        table_map[0xa655] = 0xa654;
        table_map[0xa657] = 0xa656;
        table_map[0xa659] = 0xa658;
        table_map[0xa65b] = 0xa65a;
        table_map[0xa65d] = 0xa65c;
        table_map[0xa65f] = 0xa65e;
        table_map[0xa661] = 0xa660;
        table_map[0xa663] = 0xa662;
        table_map[0xa665] = 0xa664;
        table_map[0xa667] = 0xa666;
        table_map[0xa669] = 0xa668;
        table_map[0xa66b] = 0xa66a;
        table_map[0xa66d] = 0xa66c;
        table_map[0xa681] = 0xa680;
        table_map[0xa683] = 0xa682;
        table_map[0xa685] = 0xa684;
        table_map[0xa687] = 0xa686;
        table_map[0xa689] = 0xa688;
        table_map[0xa68b] = 0xa68a;
        table_map[0xa68d] = 0xa68c;
        table_map[0xa68f] = 0xa68e;
        table_map[0xa691] = 0xa690;
        table_map[0xa693] = 0xa692;
        table_map[0xa695] = 0xa694;
        table_map[0xa697] = 0xa696;
        table_map[0xa699] = 0xa698;
        table_map[0xa69b] = 0xa69a;
        table_map[0xa723] = 0xa722;
        table_map[0xa725] = 0xa724;
        table_map[0xa727] = 0xa726;
        table_map[0xa729] = 0xa728;
        table_map[0xa72b] = 0xa72a;
        table_map[0xa72d] = 0xa72c;
        table_map[0xa72f] = 0xa72e;
        table_map[0xa733] = 0xa732;
        table_map[0xa735] = 0xa734;
        table_map[0xa737] = 0xa736;
        table_map[0xa739] = 0xa738;
        table_map[0xa73b] = 0xa73a;
        table_map[0xa73d] = 0xa73c;
        table_map[0xa73f] = 0xa73e;
        table_map[0xa741] = 0xa740;
        table_map[0xa743] = 0xa742;
        table_map[0xa745] = 0xa744;
        table_map[0xa747] = 0xa746;
        table_map[0xa749] = 0xa748;
        table_map[0xa74b] = 0xa74a;
        table_map[0xa74d] = 0xa74c;
        table_map[0xa74f] = 0xa74e;
        table_map[0xa751] = 0xa750;
        table_map[0xa753] = 0xa752;
        table_map[0xa755] = 0xa754;
        table_map[0xa757] = 0xa756;
        table_map[0xa759] = 0xa758;
        table_map[0xa75b] = 0xa75a;
        table_map[0xa75d] = 0xa75c;
        table_map[0xa75f] = 0xa75e;
        table_map[0xa761] = 0xa760;
        table_map[0xa763] = 0xa762;
        table_map[0xa765] = 0xa764;
        table_map[0xa767] = 0xa766;
        table_map[0xa769] = 0xa768;
        table_map[0xa76b] = 0xa76a;
        table_map[0xa76d] = 0xa76c;
        table_map[0xa76f] = 0xa76e;
        table_map[0xa77a] = 0xa779;
        table_map[0xa77c] = 0xa77b;
        table_map[0xa77f] = 0xa77e;
        table_map[0xa781] = 0xa780;
        table_map[0xa783] = 0xa782;
        table_map[0xa785] = 0xa784;
        table_map[0xa787] = 0xa786;
        table_map[0xa78c] = 0xa78b;
        table_map[0xa791] = 0xa790;
        table_map[0xa793] = 0xa792;
        table_map[0xa794] = 0xa7c4;
        table_map[0xa797] = 0xa796;
        table_map[0xa799] = 0xa798;
        table_map[0xa79b] = 0xa79a;
        table_map[0xa79d] = 0xa79c;
        table_map[0xa79f] = 0xa79e;
        table_map[0xa7a1] = 0xa7a0;
        table_map[0xa7a3] = 0xa7a2;
        table_map[0xa7a5] = 0xa7a4;
        table_map[0xa7a7] = 0xa7a6;
        table_map[0xa7a9] = 0xa7a8;
        table_map[0xa7b5] = 0xa7b4;
        table_map[0xa7b7] = 0xa7b6;
        table_map[0xa7b9] = 0xa7b8;
        table_map[0xa7bb] = 0xa7ba;
        table_map[0xa7bd] = 0xa7bc;
        table_map[0xa7bf] = 0xa7be;
        table_map[0xa7c1] = 0xa7c0;
        table_map[0xa7c3] = 0xa7c2;
        table_map[0xa7c8] = 0xa7c7;
        table_map[0xa7ca] = 0xa7c9;
        table_map[0xa7cd] = 0xa7cc;
        table_map[0xa7d1] = 0xa7d0;
        table_map[0xa7d7] = 0xa7d6;
        table_map[0xa7d9] = 0xa7d8;
        table_map[0xa7db] = 0xa7da;
        table_map[0xa7f6] = 0xa7f5;
        table_map[0xab53] = 0xa7b3;
        table_map[0xab70] = 0x13a0;
        table_map[0xab71] = 0x13a1;
        table_map[0xab72] = 0x13a2;
        table_map[0xab73] = 0x13a3;
        table_map[0xab74] = 0x13a4;
        table_map[0xab75] = 0x13a5;
        table_map[0xab76] = 0x13a6;
        table_map[0xab77] = 0x13a7;
        table_map[0xab78] = 0x13a8;
        table_map[0xab79] = 0x13a9;
        table_map[0xab7a] = 0x13aa;
        table_map[0xab7b] = 0x13ab;
        table_map[0xab7c] = 0x13ac;
        table_map[0xab7d] = 0x13ad;
        table_map[0xab7e] = 0x13ae;
        table_map[0xab7f] = 0x13af;
        table_map[0xab80] = 0x13b0;
        table_map[0xab81] = 0x13b1;
        table_map[0xab82] = 0x13b2;
        table_map[0xab83] = 0x13b3;
        table_map[0xab84] = 0x13b4;
        table_map[0xab85] = 0x13b5;
        table_map[0xab86] = 0x13b6;
        table_map[0xab87] = 0x13b7;
        table_map[0xab88] = 0x13b8;
        table_map[0xab89] = 0x13b9;
        table_map[0xab8a] = 0x13ba;
        table_map[0xab8b] = 0x13bb;
        table_map[0xab8c] = 0x13bc;
        table_map[0xab8d] = 0x13bd;
        table_map[0xab8e] = 0x13be;
        table_map[0xab8f] = 0x13bf;
        table_map[0xab90] = 0x13c0;
        table_map[0xab91] = 0x13c1;
        table_map[0xab92] = 0x13c2;
        table_map[0xab93] = 0x13c3;
        table_map[0xab94] = 0x13c4;
        table_map[0xab95] = 0x13c5;
        table_map[0xab96] = 0x13c6;
        table_map[0xab97] = 0x13c7;
        table_map[0xab98] = 0x13c8;
        table_map[0xab99] = 0x13c9;
        table_map[0xab9a] = 0x13ca;
        table_map[0xab9b] = 0x13cb;
        table_map[0xab9c] = 0x13cc;
        table_map[0xab9d] = 0x13cd;
        table_map[0xab9e] = 0x13ce;
        table_map[0xab9f] = 0x13cf;
        table_map[0xaba0] = 0x13d0;
        table_map[0xaba1] = 0x13d1;
        table_map[0xaba2] = 0x13d2;
        table_map[0xaba3] = 0x13d3;
        table_map[0xaba4] = 0x13d4;
        table_map[0xaba5] = 0x13d5;
        table_map[0xaba6] = 0x13d6;
        table_map[0xaba7] = 0x13d7;
        table_map[0xaba8] = 0x13d8;
        table_map[0xaba9] = 0x13d9;
        table_map[0xabaa] = 0x13da;
        table_map[0xabab] = 0x13db;
        table_map[0xabac] = 0x13dc;
        table_map[0xabad] = 0x13dd;
        table_map[0xabae] = 0x13de;
        table_map[0xabaf] = 0x13df;
        table_map[0xabb0] = 0x13e0;
        table_map[0xabb1] = 0x13e1;
        table_map[0xabb2] = 0x13e2;
        table_map[0xabb3] = 0x13e3;
        table_map[0xabb4] = 0x13e4;
        table_map[0xabb5] = 0x13e5;
        table_map[0xabb6] = 0x13e6;
        table_map[0xabb7] = 0x13e7;
        table_map[0xabb8] = 0x13e8;
        table_map[0xabb9] = 0x13e9;
        table_map[0xabba] = 0x13ea;
        table_map[0xabbb] = 0x13eb;
        table_map[0xabbc] = 0x13ec;
        table_map[0xabbd] = 0x13ed;
        table_map[0xabbe] = 0x13ee;
        table_map[0xabbf] = 0x13ef;
        table_map[0xff41] = 0xff21;
        table_map[0xff42] = 0xff22;
        table_map[0xff43] = 0xff23;
        table_map[0xff44] = 0xff24;
        table_map[0xff45] = 0xff25;
        table_map[0xff46] = 0xff26;
        table_map[0xff47] = 0xff27;
        table_map[0xff48] = 0xff28;
        table_map[0xff49] = 0xff29;
        table_map[0xff4a] = 0xff2a;
        table_map[0xff4b] = 0xff2b;
        table_map[0xff4c] = 0xff2c;
        table_map[0xff4d] = 0xff2d;
        table_map[0xff4e] = 0xff2e;
        table_map[0xff4f] = 0xff2f;
        table_map[0xff50] = 0xff30;
        table_map[0xff51] = 0xff31;
        table_map[0xff52] = 0xff32;
        table_map[0xff53] = 0xff33;
        table_map[0xff54] = 0xff34;
        table_map[0xff55] = 0xff35;
        table_map[0xff56] = 0xff36;
        table_map[0xff57] = 0xff37;
        table_map[0xff58] = 0xff38;
        table_map[0xff59] = 0xff39;
        table_map[0xff5a] = 0xff3a;
        table_map[0x10428] = 0x10400;
        table_map[0x10429] = 0x10401;
        table_map[0x1042a] = 0x10402;
        table_map[0x1042b] = 0x10403;
        table_map[0x1042c] = 0x10404;
        table_map[0x1042d] = 0x10405;
        table_map[0x1042e] = 0x10406;
        table_map[0x1042f] = 0x10407;
        table_map[0x10430] = 0x10408;
        table_map[0x10431] = 0x10409;
        table_map[0x10432] = 0x1040a;
        table_map[0x10433] = 0x1040b;
        table_map[0x10434] = 0x1040c;
        table_map[0x10435] = 0x1040d;
        table_map[0x10436] = 0x1040e;
        table_map[0x10437] = 0x1040f;
        table_map[0x10438] = 0x10410;
        table_map[0x10439] = 0x10411;
        table_map[0x1043a] = 0x10412;
        table_map[0x1043b] = 0x10413;
        table_map[0x1043c] = 0x10414;
        table_map[0x1043d] = 0x10415;
        table_map[0x1043e] = 0x10416;
        table_map[0x1043f] = 0x10417;
        table_map[0x10440] = 0x10418;
        table_map[0x10441] = 0x10419;
        table_map[0x10442] = 0x1041a;
        table_map[0x10443] = 0x1041b;
        table_map[0x10444] = 0x1041c;
        table_map[0x10445] = 0x1041d;
        table_map[0x10446] = 0x1041e;
        table_map[0x10447] = 0x1041f;
        table_map[0x10448] = 0x10420;
        table_map[0x10449] = 0x10421;
        table_map[0x1044a] = 0x10422;
        table_map[0x1044b] = 0x10423;
        table_map[0x1044c] = 0x10424;
        table_map[0x1044d] = 0x10425;
        table_map[0x1044e] = 0x10426;
        table_map[0x1044f] = 0x10427;
        table_map[0x104d8] = 0x104b0;
        table_map[0x104d9] = 0x104b1;
        table_map[0x104da] = 0x104b2;
        table_map[0x104db] = 0x104b3;
        table_map[0x104dc] = 0x104b4;
        table_map[0x104dd] = 0x104b5;
        table_map[0x104de] = 0x104b6;
        table_map[0x104df] = 0x104b7;
        table_map[0x104e0] = 0x104b8;
        table_map[0x104e1] = 0x104b9;
        table_map[0x104e2] = 0x104ba;
        table_map[0x104e3] = 0x104bb;
        table_map[0x104e4] = 0x104bc;
        table_map[0x104e5] = 0x104bd;
        table_map[0x104e6] = 0x104be;
        table_map[0x104e7] = 0x104bf;
        table_map[0x104e8] = 0x104c0;
        table_map[0x104e9] = 0x104c1;
        table_map[0x104ea] = 0x104c2;
        table_map[0x104eb] = 0x104c3;
        table_map[0x104ec] = 0x104c4;
        table_map[0x104ed] = 0x104c5;
        table_map[0x104ee] = 0x104c6;
        table_map[0x104ef] = 0x104c7;
        table_map[0x104f0] = 0x104c8;
        table_map[0x104f1] = 0x104c9;
        table_map[0x104f2] = 0x104ca;
        table_map[0x104f3] = 0x104cb;
        table_map[0x104f4] = 0x104cc;
        table_map[0x104f5] = 0x104cd;
        table_map[0x104f6] = 0x104ce;
        table_map[0x104f7] = 0x104cf;
        table_map[0x104f8] = 0x104d0;
        table_map[0x104f9] = 0x104d1;
        table_map[0x104fa] = 0x104d2;
        table_map[0x104fb] = 0x104d3;
        table_map[0x10597] = 0x10570;
        table_map[0x10598] = 0x10571;
        table_map[0x10599] = 0x10572;
        table_map[0x1059a] = 0x10573;
        table_map[0x1059b] = 0x10574;
        table_map[0x1059c] = 0x10575;
        table_map[0x1059d] = 0x10576;
        table_map[0x1059e] = 0x10577;
        table_map[0x1059f] = 0x10578;
        table_map[0x105a0] = 0x10579;
        table_map[0x105a1] = 0x1057a;
        table_map[0x105a3] = 0x1057c;
        table_map[0x105a4] = 0x1057d;
        table_map[0x105a5] = 0x1057e;
        table_map[0x105a6] = 0x1057f;
        table_map[0x105a7] = 0x10580;
        table_map[0x105a8] = 0x10581;
        table_map[0x105a9] = 0x10582;
        table_map[0x105aa] = 0x10583;
        table_map[0x105ab] = 0x10584;
        table_map[0x105ac] = 0x10585;
        table_map[0x105ad] = 0x10586;
        table_map[0x105ae] = 0x10587;
        table_map[0x105af] = 0x10588;
        table_map[0x105b0] = 0x10589;
        table_map[0x105b1] = 0x1058a;
        table_map[0x105b3] = 0x1058c;
        table_map[0x105b4] = 0x1058d;
        table_map[0x105b5] = 0x1058e;
        table_map[0x105b6] = 0x1058f;
        table_map[0x105b7] = 0x10590;
        table_map[0x105b8] = 0x10591;
        table_map[0x105b9] = 0x10592;
        table_map[0x105bb] = 0x10594;
        table_map[0x105bc] = 0x10595;
        table_map[0x10cc0] = 0x10c80;
        table_map[0x10cc1] = 0x10c81;
        table_map[0x10cc2] = 0x10c82;
        table_map[0x10cc3] = 0x10c83;
        table_map[0x10cc4] = 0x10c84;
        table_map[0x10cc5] = 0x10c85;
        table_map[0x10cc6] = 0x10c86;
        table_map[0x10cc7] = 0x10c87;
        table_map[0x10cc8] = 0x10c88;
        table_map[0x10cc9] = 0x10c89;
        table_map[0x10cca] = 0x10c8a;
        table_map[0x10ccb] = 0x10c8b;
        table_map[0x10ccc] = 0x10c8c;
        table_map[0x10ccd] = 0x10c8d;
        table_map[0x10cce] = 0x10c8e;
        table_map[0x10ccf] = 0x10c8f;
        table_map[0x10cd0] = 0x10c90;
        table_map[0x10cd1] = 0x10c91;
        table_map[0x10cd2] = 0x10c92;
        table_map[0x10cd3] = 0x10c93;
        table_map[0x10cd4] = 0x10c94;
        table_map[0x10cd5] = 0x10c95;
        table_map[0x10cd6] = 0x10c96;
        table_map[0x10cd7] = 0x10c97;
        table_map[0x10cd8] = 0x10c98;
        table_map[0x10cd9] = 0x10c99;
        table_map[0x10cda] = 0x10c9a;
        table_map[0x10cdb] = 0x10c9b;
        table_map[0x10cdc] = 0x10c9c;
        table_map[0x10cdd] = 0x10c9d;
        table_map[0x10cde] = 0x10c9e;
        table_map[0x10cdf] = 0x10c9f;
        table_map[0x10ce0] = 0x10ca0;
        table_map[0x10ce1] = 0x10ca1;
        table_map[0x10ce2] = 0x10ca2;
        table_map[0x10ce3] = 0x10ca3;
        table_map[0x10ce4] = 0x10ca4;
        table_map[0x10ce5] = 0x10ca5;
        table_map[0x10ce6] = 0x10ca6;
        table_map[0x10ce7] = 0x10ca7;
        table_map[0x10ce8] = 0x10ca8;
        table_map[0x10ce9] = 0x10ca9;
        table_map[0x10cea] = 0x10caa;
        table_map[0x10ceb] = 0x10cab;
        table_map[0x10cec] = 0x10cac;
        table_map[0x10ced] = 0x10cad;
        table_map[0x10cee] = 0x10cae;
        table_map[0x10cef] = 0x10caf;
        table_map[0x10cf0] = 0x10cb0;
        table_map[0x10cf1] = 0x10cb1;
        table_map[0x10cf2] = 0x10cb2;
        table_map[0x10d70] = 0x10d50;
        table_map[0x10d71] = 0x10d51;
        table_map[0x10d72] = 0x10d52;
        table_map[0x10d73] = 0x10d53;
        table_map[0x10d74] = 0x10d54;
        table_map[0x10d75] = 0x10d55;
        table_map[0x10d76] = 0x10d56;
        table_map[0x10d77] = 0x10d57;
        table_map[0x10d78] = 0x10d58;
        table_map[0x10d79] = 0x10d59;
        table_map[0x10d7a] = 0x10d5a;
        table_map[0x10d7b] = 0x10d5b;
        table_map[0x10d7c] = 0x10d5c;
        table_map[0x10d7d] = 0x10d5d;
        table_map[0x10d7e] = 0x10d5e;
        table_map[0x10d7f] = 0x10d5f;
        table_map[0x10d80] = 0x10d60;
        table_map[0x10d81] = 0x10d61;
        table_map[0x10d82] = 0x10d62;
        table_map[0x10d83] = 0x10d63;
        table_map[0x10d84] = 0x10d64;
        table_map[0x10d85] = 0x10d65;
        table_map[0x118c0] = 0x118a0;
        table_map[0x118c1] = 0x118a1;
        table_map[0x118c2] = 0x118a2;
        table_map[0x118c3] = 0x118a3;
        table_map[0x118c4] = 0x118a4;
        table_map[0x118c5] = 0x118a5;
        table_map[0x118c6] = 0x118a6;
        table_map[0x118c7] = 0x118a7;
        table_map[0x118c8] = 0x118a8;
        table_map[0x118c9] = 0x118a9;
        table_map[0x118ca] = 0x118aa;
        table_map[0x118cb] = 0x118ab;
        table_map[0x118cc] = 0x118ac;
        table_map[0x118cd] = 0x118ad;
        table_map[0x118ce] = 0x118ae;
        table_map[0x118cf] = 0x118af;
        table_map[0x118d0] = 0x118b0;
        table_map[0x118d1] = 0x118b1;
        table_map[0x118d2] = 0x118b2;
        table_map[0x118d3] = 0x118b3;
        table_map[0x118d4] = 0x118b4;
        table_map[0x118d5] = 0x118b5;
        table_map[0x118d6] = 0x118b6;
        table_map[0x118d7] = 0x118b7;
        table_map[0x118d8] = 0x118b8;
        table_map[0x118d9] = 0x118b9;
        table_map[0x118da] = 0x118ba;
        table_map[0x118db] = 0x118bb;
        table_map[0x118dc] = 0x118bc;
        table_map[0x118dd] = 0x118bd;
        table_map[0x118de] = 0x118be;
        table_map[0x118df] = 0x118bf;
        table_map[0x16e60] = 0x16e40;
        table_map[0x16e61] = 0x16e41;
        table_map[0x16e62] = 0x16e42;
        table_map[0x16e63] = 0x16e43;
        table_map[0x16e64] = 0x16e44;
        table_map[0x16e65] = 0x16e45;
        table_map[0x16e66] = 0x16e46;
        table_map[0x16e67] = 0x16e47;
        table_map[0x16e68] = 0x16e48;
        table_map[0x16e69] = 0x16e49;
        table_map[0x16e6a] = 0x16e4a;
        table_map[0x16e6b] = 0x16e4b;
        table_map[0x16e6c] = 0x16e4c;
        table_map[0x16e6d] = 0x16e4d;
        table_map[0x16e6e] = 0x16e4e;
        table_map[0x16e6f] = 0x16e4f;
        table_map[0x16e70] = 0x16e50;
        table_map[0x16e71] = 0x16e51;
        table_map[0x16e72] = 0x16e52;
        table_map[0x16e73] = 0x16e53;
        table_map[0x16e74] = 0x16e54;
        table_map[0x16e75] = 0x16e55;
        table_map[0x16e76] = 0x16e56;
        table_map[0x16e77] = 0x16e57;
        table_map[0x16e78] = 0x16e58;
        table_map[0x16e79] = 0x16e59;
        table_map[0x16e7a] = 0x16e5a;
        table_map[0x16e7b] = 0x16e5b;
        table_map[0x16e7c] = 0x16e5c;
        table_map[0x16e7d] = 0x16e5d;
        table_map[0x16e7e] = 0x16e5e;
        table_map[0x16e7f] = 0x16e5f;
        table_map[0x1e922] = 0x1e900;
        table_map[0x1e923] = 0x1e901;
        table_map[0x1e924] = 0x1e902;
        table_map[0x1e925] = 0x1e903;
        table_map[0x1e926] = 0x1e904;
        table_map[0x1e927] = 0x1e905;
        table_map[0x1e928] = 0x1e906;
        table_map[0x1e929] = 0x1e907;
        table_map[0x1e92a] = 0x1e908;
        table_map[0x1e92b] = 0x1e909;
        table_map[0x1e92c] = 0x1e90a;
        table_map[0x1e92d] = 0x1e90b;
        table_map[0x1e92e] = 0x1e90c;
        table_map[0x1e92f] = 0x1e90d;
        table_map[0x1e930] = 0x1e90e;
        table_map[0x1e931] = 0x1e90f;
        table_map[0x1e932] = 0x1e910;
        table_map[0x1e933] = 0x1e911;
        table_map[0x1e934] = 0x1e912;
        table_map[0x1e935] = 0x1e913;
        table_map[0x1e936] = 0x1e914;
        table_map[0x1e937] = 0x1e915;
        table_map[0x1e938] = 0x1e916;
        table_map[0x1e939] = 0x1e917;
        table_map[0x1e93a] = 0x1e918;
        table_map[0x1e93b] = 0x1e919;
        table_map[0x1e93c] = 0x1e91a;
        table_map[0x1e93d] = 0x1e91b;
        table_map[0x1e93e] = 0x1e91c;
        table_map[0x1e93f] = 0x1e91d;
        table_map[0x1e940] = 0x1e91e;
        table_map[0x1e941] = 0x1e91f;
        table_map[0x1e942] = 0x1e920;
        table_map[0x1e943] = 0x1e921;
        for (uint32_t i = 0; i < 0x1e9ff; ++i) {
            if (table_map.count(i) == 0) {
                CHECK(argparse::detail::_to_upper_codepoint(i) == i);
            }
        }
        for (std::map<uint32_t, uint32_t>::const_iterator it = table_map.begin(); it != table_map.end(); ++it) {
            CHECK(argparse::detail::_to_upper_codepoint(it->first) == it->second);
        }
    }
}
